// rkbp.C

#include "rkbp.h"


static long        nargs;
static char       *args[20];
double             hybrid_factor = 0.5;
static char        file_name[50] = "";
static char        file[50];
static char        kb_strategy[50] = "";
static char        algorithm[50];
static int         timing = 0;

long               print_level = 0;


extern void      help(void);


int main()
{
  long              command_length,i,code,numsub;
  long              bsize=1000, maxlen,prevlen,num_iter;
  long              savell,savelr,num,maxill,maxilr;
  long              maxtll,maxtlr,nsm;
  long              ntrials,depth,exponent,flag;
  long              firstg,lastg,engelnum,subno;
  long              seed,maxlev = LONG_MAX;
  long              shift;
  ulong             maxmem;
  ulong             llmin,llmax,lrmin,lrmax,genmin,genmax;
  double            cpu;
  char              command[501],p_command[501];
  char              str[500],*pchar,string[100],*str1;
  external_form     logform,extfrm;
  bool              confluent,prompt;
  rule_type         rtype;
  rewriting_system *syst = NULL;
  void  huge       *dummy;
  vector_long       wrd;


  start_time();

  cout << "\nRutgers Knuth-Bendix Package, Version 1.43\n\n";


  ////  Set defaults. //////////////////////////////


  set_echo(FALSE);

  prevlen = 0;
  cout << "\n";
  

  //// Run command read-execute loop. //////////////////////


  for (;;) {
    cpu = get_time();

    if (timing)
      cout << endl << "Total cpu time:  " << cpu 
           << " seconds." << endl << endl;

    cout << ">: ";

    // Read in the next command line.  Only the first 500
    // characters are significant.

    if ( !cin.get(command,500) ) {
      cout << "Input error reading command line." << endl;
      if ( !cin.ignore(10000,'\n') ) goto clear_error;
      goto cont;
    }

    if ( !cin.ignore(10000,'\n') ) goto clear_error;

    command_length = strlen(command);
    if ( get_echo() ) cout << command << endl;

    if (command_length == 0) continue;

    strcpy(p_command,command);
    nargs = parse(p_command,args,20);
    if (nargs == 0) continue;

    if (args[0][0] == '!') {
      // This is a system command.  Pass it to operating system.

      i = 0;
      while (command[i] == ' ') i++;
      code = system(command+i+1);

      if (code != 0) cout << "Command returned code " << code
         << endl;

      continue;
    }

    if ('#' == args[0][0]) {
      // This is a comment.  Ignore it.

      continue;
    }

    // Execute the command.  Make sure the first word is in
    // lower case.


    to_lower(args[0]);

    ////  add_engel  //////////////////////////////////////////

    if (0 == strcmp(args[0],"add_engel") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter Engel number:  ";
        cin  >> engelnum;

        if (get_echo() ) cout << engelnum << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else engelnum = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter maximum length of substituted words:  ";
        cin >> maxlen;

        if (get_echo() ) cout << maxlen << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[2]);

      if (nargs <= 3) {
        cout << "Enter first generator (internal number):  ";
        cin  >> firstg;
        if (get_echo() ) cout << firstg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else firstg = atol(args[3]);

      if (nargs <= 4) {
        cout << "Enter last generator (internal number):  ";
        cin  >> lastg;
        if (get_echo() ) cout << lastg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else lastg = atol(args[4]);

      if (nargs <= 5) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[5]);

      if (nargs <= 6) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[6]);
      
      syst->set_save(savell,savelr);
      syst->add_engel(engelnum,firstg,lastg,maxlen);
      prevlen = 0;
    }

    ////  add_instances  //////////////////////////////////////

    else if (0 == strcmp(args[0],"add_instances") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter subsystem number:  ";
        cin  >> subno;
        if (get_echo() ) cout << subno << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else subno = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter maximum length of initial left sides:  ";
        cin  >> maxill;
        if (get_echo() ) cout << maxill << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxill = atol(args[2]);

      if (nargs <= 3) {
        cout << "Enter maximum length of initial right sides:  ";
        cin  >> maxilr;
        if (get_echo() ) cout << maxilr << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxilr = atol(args[3]);

      if (nargs <= 4) {
        cout << "Enter maximum length of substituted words:  ";
        cin  >> maxlen;
        if (get_echo() ) cout << maxlen << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[4]);

      if (nargs <= 5) {
        cout << "Enter first generator (internal number):  ";
        cin  >> firstg;
        if (get_echo() ) cout << firstg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else firstg = atol(args[5]);

      if (nargs <= 6) {
        cout << "Enter last generator (internal number):  ";
        cin  >> lastg;
        if (get_echo() ) cout << lastg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else lastg = atol(args[6]);

      if (nargs <= 7) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[7]);

      if (nargs <= 8) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[8]);
      
      syst->set_save(savell,savelr);
      syst->add_instances(subno,maxill,maxilr,maxlen,firstg,lastg);
      prevlen = 0;
    }

    ////  add_powers  /////////////////////////////////////////

    else if (0 == strcmp(args[0],"add_powers") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter exponent:  ";
        cin >> exponent;

        if (get_echo() ) cout << exponent << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else exponent = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter maximum length of words:  ";
        cin >> maxlen;

        if (get_echo() ) cout << maxlen << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[2]);

      if (nargs <= 3) {
        cout << "Enter first generator (internal number):  ";
        cin  >> firstg;
        if (get_echo() ) cout << firstg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else firstg = atol(args[3]);

      if (nargs <= 4) {
        cout << "Enter last generator (internal number):  ";
        cin  >> lastg;
        if (get_echo() ) cout << lastg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else lastg = atol(args[4]);

      if (nargs <= 5) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[5]);

      if (nargs <= 6) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[6]);
      
      syst->set_save(savell,savelr);
      syst->add_powers(exponent,maxlen,firstg,lastg);
      prevlen = 0;
    }

    ////  add_random_powers  ////////////////////////////////////

    else if (0 == strcmp(args[0],"add_random_powers") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter number of trials:  ";
        cin  >> ntrials;

        if (get_echo() ) cout << ntrials << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else ntrials = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter exponent:  ";
        cin >> exponent;

        if (get_echo() ) cout << exponent << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else exponent = atol(args[2]);

      if (nargs <= 3) {
        cout << "Enter maximum length of words:  ";
        cin >> maxlen;

        if (get_echo() ) cout << maxlen << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[3]);

      if (nargs <= 4) {
        cout << "Enter first generator (internal number):  ";
        cin  >> firstg;
        if (get_echo() ) cout << firstg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else firstg = atol(args[4]);

      if (nargs <= 5) {
        cout << "Enter last generator (internal number):  ";
        cin  >> lastg;
        if (get_echo() ) cout << lastg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else lastg = atol(args[5]);

      if (nargs <= 6) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[6]);

      if (nargs <= 7) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[7]);
      
      syst->set_save(savell,savelr);
      syst->add_random_powers(ntrials,exponent,maxlen,firstg,lastg);
      prevlen = 0;
    }

    ////  add_subs  ////////////////////////////////////////////

    else if (0 == strcmp(args[0],"add_subs") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter maximum length of initial left sides:  ";
        cin  >> maxill;
        if (get_echo() ) cout << maxill << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxill = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter maximum length of initial right sides:  ";
        cin  >> maxilr;
        if (get_echo() ) cout << maxilr << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxilr = atol(args[2]);

      if (nargs <= 3) {
        cout << "Enter maximum total length of left sides:  ";
        cin  >> maxtll;
        if (get_echo() ) cout << maxtll << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxtll = atol(args[3]);

      if (nargs <= 4) {
        cout << "Enter maximum total length of right sides:  ";
        cin  >> maxtlr;
        if (get_echo() ) cout << maxtlr << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxtlr = atol(args[4]);

      if (nargs <= 5) {
        cout << "Enter maximum length of substituted words:  ";
        cin  >> maxlen;
        if (get_echo() ) cout << maxlen << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[5]);

      if (nargs <= 6) {
        cout << "Enter first generator (internal number):  ";
        cin  >> firstg;
        if (get_echo() ) cout << firstg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else firstg = atol(args[6]);

      if (nargs <= 7) {
        cout << "Enter last generator (internal number):  ";
        cin  >> lastg;
        if (get_echo() ) cout << lastg << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else lastg = atol(args[7]);

      if (nargs <= 8) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[8]);

      if (nargs <= 9) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[9]);
      
      syst->set_save(savell,savelr);
      syst->add_subs(maxill,maxilr,maxtll,maxtlr,maxlen,
                      firstg,lastg);
      prevlen = 0;
    }

    ////  add_subword_powers  ////////////////////////////////////

    else if (0 == strcmp(args[0],"add_subword_powers") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter exponent:  ";
        cin >> exponent;

        if (get_echo() ) cout << exponent << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else exponent = atol(args[1]);

      if (nargs <= 2) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[2]);

      if (nargs <= 3) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[3]);
      
      syst->set_save(savell,savelr);
      syst->add_subword_powers(exponent);
      prevlen = 0;
    }

    ////  broken //////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"broken") ) {
      if (NULL == syst) goto no_sys;
      syst->set_use_broken(TRUE);
    }

    ////  bsize  //////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"bsize") ) {
      if (nargs <= 1) {
        cout << "Enter value for bsize:  ";
        cin >> bsize;

        if (get_echo() ) cout << bsize << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else bsize = atol(args[1]);

      if (syst != NULL) syst->set_bsize(bsize);
    }

    ////  cancel  /////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"cancel") ) {
      if (NULL == syst) goto no_sys;

      syst->cancel();
    }

    ////  conjugate  //////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"conjugate") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter niter (-1 for infinity):  ";
        cin  >> num_iter;

        if (get_echo() ) cout << num_iter << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else num_iter = atol(args[1]);

      if (nargs <= 2) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[2]);

      if (nargs <= 3) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[3]);
      
      syst->set_save(savell,savelr);

      syst->conjugate(num_iter);
    }

    ////  count  //////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"count") ) {
      if (syst == NULL) goto no_sys;
      if (nargs <= 1) {
        cout << "Enter maximum length of words:  ";
        cin >> maxlen;

        if (get_echo() ) cout << maxlen << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[1]);

      cout << "Enter (possibly empty) prefix in names format:  "
           << endl;

      wrd.set_max_length(maxlen);
      code = syst->read_word(cin,NAMES,0,wrd);

      if (code == 1 || code == 2)
        cout << "Problem reading prefix" << endl;
        
      else {
        if (get_echo() ) {
          syst->print_word(cout,NAMES,wrd);
          cout << endl;
        }

        syst->count(wrd,maxlen);
      }
    }

    ////  count_subgroup  //////////////////////////////////////

    else if ( 0 == strcmp(args[0],"count_subgroup") ) {
      if (syst == NULL) goto no_sys;

      syst->count_subgroup();
    }

    ////  countg  /////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"countg") ) {
      if (syst == NULL) goto no_sys;
      if (nargs <= 1) {
        cout << "Enter maximum length of words:  ";
        cin >> maxlen;

        if (get_echo() ) cout << maxlen << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[1]);

      cout << "Enter (possibly empty) prefix in names format:  "
           << endl;

      wrd.set_max_length(maxlen);
      code = syst->read_word(cin,NAMES,0,wrd);

      if (code == 1 || code == 2)
        cout << "Problem reading prefix" << endl;
        
      else {
        if (get_echo() ) {
          syst->print_word(cout,NAMES,wrd);
          cout << endl;
        }

        syst->countg(wrd,maxlen);
      }
    }

    ////  counts  /////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"counts") ) {
      if (syst == NULL) goto no_sys;
      
      syst->print_counts();
    }

    ////  countx  /////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"countx") ) {
      if (syst == NULL) goto no_sys;
      if (nargs <= 1) {
        cout << "Enter maximum length of words:  ";
        cin >> maxlen;

        if (get_echo() ) cout << maxlen << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[1]);

      cout << "Enter (possibly empty) prefix in names format:  "
           << endl;

      wrd.set_max_length(maxlen);
      code = syst->read_word(cin,NAMES,0,wrd);

      if (code == 1 || code == 2)
        cout << "Problem reading prefix" << endl;
        
      else {
        if (get_echo() ) {
          syst->print_word(cout,NAMES,wrd);
          cout << endl;
        }

        syst->countx(wrd,maxlen);
      }
    }

    ////  details  /////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"details") ) {
      if (syst == NULL) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter number of subsystem (or -1 for all):  ";
        cin >> num;

        if (get_echo() ) cout << num << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else num = atol(args[1]);

      syst->details(num);
    }

    ////  dots  ////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"dots") )    set_dots(TRUE);

    ////  echo  ////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"echo") ) {
      set_echo(TRUE);
      cout << endl;
    }

    //// exit  /////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"exit") )    break;

    ////  free  ////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"free") ) {
      if (syst == NULL) goto no_sys;

      delete syst;
      syst = NULL;
      prevlen = 0;
      maxlev  = LONG_MAX;
    }

    ////  geodesics  /////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"geodesics") ) {
      if (syst == NULL) goto no_sys;
      if (nargs <= 1) {
        cout << "Enter maximum length of words:  ";
        cin >> maxlen;

        if (get_echo() ) cout << maxlen << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[1]);

      cout << "Enter (possibly empty) prefix in names format:  "
           << endl;

      wrd.set_max_length(maxlen);
      code = syst->read_word(cin,NAMES,0,wrd);

      if (code == 1 || code == 2)
        cout << "Problem reading prefix" << endl;
        
      else {
        if (get_echo() ) {
          syst->print_word(cout,NAMES,wrd);
          cout << endl;
        }

        syst->geodesics(wrd,maxlen);
      }
    }

    ////  get_nonobvious  //////////////////////////////////////

    else if ( 0 == strcmp(args[0],"get_nonobvious") ) {
      if (syst == NULL) goto no_sys;
      syst->get_nonobvious();
    }	

    ////  help  ////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"help") ||
              args[0][0] == '?'             ) help();

    ////  heuristics  //////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"heuristics") ) {
      if (syst == NULL) goto no_sys;
      syst->set_use_heuristics(TRUE);
    }

    ////  hybrid_factor  ///////////////////////////////////////

    else if ( 0 == strcmp(args[0],"hybrid_factor") ) {
      if (nargs <= 1) {
        cout <<
          "Enter hybrid_factor (positive decimal number):  ";
        cin  >> hybrid_factor;

        if (get_echo() ) cout << hybrid_factor << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else hybrid_factor = atof(args[1]);

      set_hybrid_factor(hybrid_factor);
    }

    ////  input  ///////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"input") ) {
      if (syst != NULL) {
        cout <<
         "A system already exists.  You must explicitly free\n"
        << "it.\n";

        continue;
      }

      syst = new rewriting_system;
      if (bsize > 0) syst->set_bsize(bsize);
      
      if (nargs > 1) syst->input(args[1],TRUE);
      else syst->input("",TRUE);
    }

    ////  kb  //////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"kb") ) {
      flag = 7;

     kb_arguments:
      if (syst == NULL) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter maxlen (0 for prevlen+1):  ";
        cin  >> maxlen;

        if (get_echo() ) cout << maxlen << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;

        if (maxlen <= 0) maxlen = prevlen+1;
      }
      
      else maxlen = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter niter (-1 for infinity):  ";
        cin  >> num_iter;

        if (get_echo() ) cout << num_iter << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else num_iter = atol(args[2]);

      if (nargs <= 3) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[3]);

      if (nargs <= 4) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[4]);
      
      syst->set_save(savell,savelr);

      confluent = syst->kb_two_step(maxlev,maxlen,
                   num_iter,prevlen,flag);
//      confluent = (syst->*(syst->pKnuth_Bendix))(maxlev,maxlen,
//                   num_iter,prevlen,flag);

      if (confluent) prevlen = maxlen;
      else prevlen = 0;
    }

    ////  kb_prefix  //////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"kb_prefix") ) {
      flag = 6;
      goto kb_arguments;
    }

    ////  kb_random  //////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"kb_random") ) {
      if (syst == NULL) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter ntrials:  ";
        cin  >> ntrials;

        if (get_echo() ) cout << ntrials << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else ntrials = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter rule type (prefix or subword):  ";
        cin  >> str;
        if (get_echo() ) cout << str << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
        pchar = str;
      }

      else pchar = args[2];

      to_lower(pchar);

      if (0 == strcmp(pchar,"prefix") )       rtype = PREFIX_RULE;
      else if (0 == strcmp(pchar,"subword") ) rtype = SUBWORD_RULE;

      else {
        cout << "Invalid rule type" << endl;
        continue;
      }

      if (nargs <= 3) {
        cout << "Enter maxlen:  ";
        cin  >> maxlen;

        if (get_echo() ) cout << maxlen << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;

        if (maxlen <= 0) maxlen = prevlen+1;
      }
      
      else maxlen = atol(args[3]);

      if (nargs <= 4) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[4]);

      if (nargs <= 5) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[5]);
      
      syst->set_save(savell,savelr);

      confluent = syst->kb_random_two_step(maxlen,rtype,ntrials);
      if (!confluent) prevlen = 0;
    }

    ////  kb_strategy  //////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"kb_strategy") ) {
      if (syst == NULL) goto no_sys;
      
      if (nargs <= 1) {
        cout <<
           "Enter Knuth-Bendix strategy (basic or two_step):  ";
        cin >> kb_strategy;

        if (get_echo() ) cout << kb_strategy << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
        
        args[1] = kb_strategy;
      }

      if ( 0 == strcmp(args[1],"basic") )
        syst->set_kb_strategy(BASIC);

      else if ( 0 == strcmp(args[1],"two_step") )
        syst->set_kb_strategy(TWO_STEP);
        
      else {
        cout << "Unknown Knuth-Bendix strategy.\n";
        goto cont;
      }
    }

    ////  kb_subword  ///////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"kb_subword") ) {
      flag = 5;
      goto kb_arguments;
    }

    ////  level  ////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"level") ) {
      if (nargs <= 1) {
        cout << "Enter max level of left part of overlap:  ";
        cin  >> maxlev;
        if (get_echo() ) cout << maxlev << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlev = atol(args[1]);
    }

    ////  log  //////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"log") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter maxlen:  ";
        cin  >> maxlen;
        if (get_echo() ) cout << maxlen << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else maxlen = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter log file name:  ";
        cin  >> str;
        if (get_echo() ) cout << str << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else strcpy(str,args[2]);

      if (nargs <= 2) {
        cout << "Enter external format\n" <<
          "(names, len_names, len_numbers, or len_6bit):  ";
        scan_string(cin,string);
        str1 = string;
      }

      else str1 = args[3];

      if      (0 == strcmp(str1,"names") )
        logform = NAMES;
      else if (0 == strcmp(str1,"len_names") )
        logform = LEN_NAMES;
      else if (0 == strcmp(str1,"len_numbers") )
        logform = LEN_NUMBERS;
      else if (0 == strcmp(str1,"len_6bit") )    logform = LEN_6BIT;
      else {
        cout << "Unknown format" << endl;
        continue;
      }

      syst->log_on(maxlen,str,logform);
    }

    ////  maxnew  ///////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"maxnew") ) {
      if (syst == NULL) goto no_sys;
      
      if (nargs <= 1) {
        cout << "Enter maximum number of new rules:  ";
        cin >> nsm;
        if (get_echo() ) cout << nsm << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else nsm = atol(args[1]);

      syst->set_nsave_max(nsm);
    }

    ////  memory  ///////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"memory") ) {
      fxstat();
      if (syst != NULL) syst->memory();
    }

    ////  nobroken  /////////////////////////////////////////////

    else if (0 == strcmp(args[0],"nobroken") ) {
      if (NULL == syst) goto no_sys;
      syst->set_use_broken(FALSE);
    }

    ////  nodots  ///////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"nodots") ) set_dots(FALSE);

    ////  noecho  ///////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"noecho") ) set_echo(FALSE);

    ////  noheuristics  /////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"noheuristics") ) {
      if (NULL == syst) goto no_sys;
      syst->set_use_heuristics(FALSE);
    }

    ////  nolog  ////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"nolog") ) {
      if (NULL == syst) goto no_sys;
      syst->log_off();
    }

    ////  nopatterns  ///////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"nopatterns") ) {
      if (NULL == syst) goto no_sys;
      syst->set_use_patterns(FALSE);
    }

    ////  output  ///////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"output") ) {
      if (syst == NULL) goto no_sys;
      
      if ( nargs <= 1) {
        for (;;) {
          cout <<
            "Enter problem name for output (or \"stop\"):  ";

          cin  >> file_name;

          if (get_echo() ) cout << file_name << endl;

          if ( !cin.ignore(10000,'\n') ) goto clear_error;

          if (0 == strcmp(file_name,"stop") ) break;
          strcpy(file,file_name);
          strcat(file,".sys");

          if (file_exists(file) ) {
            cout << "File " << file << " exists." << endl;
            if (get_echo() ) exit(1);
            continue;
          }

          syst->write(file_name);
          break;
        }
      }

      else syst->write(args[1]);
    }

    ////  output_rules  /////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"output_rules") ) {
      if (syst == NULL) goto no_sys;
      
      if (0 == syst->get_n_sub() ) {
        cout << "There are no subsystems" << endl;
        goto abort;
      }

      prompt = nargs <= 1;

      for (;;) {
        if (!prompt) numsub = atol(args[2]);

        else {
          cout << "Enter subsystem number:  ";
          cin >> numsub;

          if (get_echo() ) cout << numsub << endl;
          if ( !cin.ignore(10000,'\n') ) goto clear_error;
          prompt = TRUE;
        }

        if (numsub > 0 && numsub <= syst->get_n_sub() ) break;
        cout << "Invalid subsystem number" << endl;
        if ( get_echo() ) exit(1);
      }

      prompt = nargs <= 2;

      for (;;) {
        if (prompt) {
          cout <<
            "Enter file name for output (or \"stop\"):  ";

          cin  >> file_name;

          if (get_echo() ) cout << file_name << endl;

          if ( !cin.ignore(10000,'\n') ) goto clear_error;
        }

        else {
          strcpy(file_name,args[3]);
          prompt = TRUE;
        }

        if (0 == strcmp(file_name,"stop") ) break;

        if (file_exists(file_name) ) {
          cout << "File " << file_name << " exists." << endl;
          if (get_echo() ) exit(1);
          continue;
        }

        break;
      }

      prompt = nargs <= 3;

      for (;;) {
        if (prompt) {
          cout << "Enter external format (or \"stop\"):  ";

          cin >> str;
          if (get_echo() ) cout << str << endl;
          if ( !cin.ignore(10000,'\n') )goto clear_error;
        }

        else {
          strcpy(str,args[4]);
          prompt = TRUE;
        }

        if (0 == strcmp(str,"stop") ) goto abort;

        if (0 == strcmp(str,"names") )
          extfrm = NAMES;

        else if (0 == strcmp(str,"len_names") )
          extfrm = LEN_NAMES;

        else if (0 == strcmp(str,"len_numbers") )
          extfrm = LEN_NUMBERS;

        else if (0 == strcmp(str,"len_6bit") )
          extfrm = LEN_6BIT;

        else {
          cout << "Invalid form" << endl;
          prompt = TRUE;
          continue;
        }

        break;
      }


      if (nargs <= 4) {
        cout <<
          "Enter minimum left length:  ";

        cin  >> llmin;

        if (get_echo() ) cout << llmin << endl;
      }

      else {
        llmin = atol(args[4]);
      }

      if (nargs <= 5) {
        cout <<
          "Enter maximum left length:  ";

        cin  >> llmax;

        if (get_echo() ) cout << llmax << endl;
      }

      else {
        llmax = atol(args[5]);
      }

      if (nargs <= 6) {
        cout <<
          "Enter minimum right length:  ";

        cin  >> lrmin;

        if (get_echo() ) cout << lrmin << endl;
      }

      else {
        lrmin = atol(args[6]);
      }

      if (nargs <= 7) {
        cout <<
          "Enter maximum right length:  ";

        cin  >> lrmax;

        if (get_echo() ) cout << lrmax << endl;
      }

      else {
        lrmax = atol(args[7]);
      }

      if (nargs <= 8) {
        cout <<
          "Enter minimum generator (internal notation):  ";

        cin  >> genmin;

        if (get_echo() ) cout << genmin << endl;
      }

      else {
        genmin = atol(args[8]);
      }

      if (nargs <= 9) {
        cout <<
          "Enter maximum generator:  ";

        cin  >> genmax;

        if (get_echo() ) cout << genmax << endl;
      }

      else {
        genmax = atol(args[9]);
      }

      if ( !cin.ignore(10000,'\n') ) goto clear_error;

      syst->write_rules(numsub,file_name,extfrm,llmin,llmax,
                        lrmin,lrmax,genmin,genmax);
    }

    ////  patterns  /////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"patterns") ) {
      if (NULL == syst) goto no_sys;
      syst->set_use_patterns(TRUE);
    }

    ////  print_level  //////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"print_level") ) {
      if (nargs <= 1) {
        cout << "Enter print_level (a nonnegative integer):  ";
        cin  >> print_level;

        if (get_echo() ) cout << print_level << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else print_level = atol(args[1]);
    }

    ////  probe  ////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"probe") ) {
      if (nargs <= 1) {
        cout << "Enter number of trials:  ";
        cin  >> ntrials;

        if (get_echo() ) cout << ntrials << endl;

        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else ntrials = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter maximum length:  ";
        cin  >> depth;
        if (get_echo() ) cout << depth << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else depth = atol(args[2]);

      (void) syst->probe(FALSE,ntrials,depth);
    }

    ////  probe_subword  ////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"probe_subword") ) {
      if (nargs <= 1) {
        cout << "Enter number of trials:  ";
        cin  >> ntrials;
        if (get_echo() ) cout << ntrials << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else ntrials = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter maximum length:  ";
        cin  >> depth;
        if (get_echo() ) cout << depth << endl;
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }

      else depth = atol(args[2]);

      syst->probe(TRUE,ntrials,depth);
    }

    ////  quit  /////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"quit") )    break;

    ////  report_memory  ////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"report_memory") ) fxask();

    ////  report_rewriting  /////////////////////////////////////

    else if ( 0 == strcmp(args[0],"report_rewriting") ) {
      if (syst == NULL) goto no_sys;

      syst->ask_rewrite_verbose();
    }

    ////  report_timing  ////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"report_timing") ) {
      cout << "Do you want cpu times reported (y or n):  ";

      if (YES) timing = 1;
      else timing = 0;
    }

    ////  restore  //////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"restore") ) {
      if (syst != NULL) {
        cout <<
         "A system already exists.  You must explicitly free\n"
        << "it.\n";

        continue;
      }

      syst = new rewriting_system;
      
      if (nargs > 1) syst->input(args[1],FALSE);
      else syst->input("",FALSE);
    }

    ////  rewrite_rules  ////////////////////////////////////////

    else if (0 == strcmp(args[0],"rewrite_rules") ) {
      if (syst == NULL) goto no_sys;

      syst->rewrite_rules();
      prevlen = 0;  // This line needs to be rethought.
    }

    ////  rewrite_words  ////////////////////////////////////////

    else if (0 == strcmp(args[0],"rewrite_words") ) {
      if (syst == NULL) goto no_sys;

      syst->rewrite_words();
    }

    ////  rewriting_strategy  ///////////////////////////////////

    else if ( 0 == strcmp(args[0],"rewriting_strategy") ) {
      if (syst == NULL) goto no_sys;
      
      if (nargs <= 1) {
        cout << "Enter rewriting algorithm (left or global):  ";
        cin >> algorithm;

        if (get_echo() ) cout << algorithm << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
        
        args[1] = algorithm;
      }

      if      ( 0 == strcmp(args[1],"left") )
        syst->set_rw_strategy(FROM_LEFT);

      else if ( 0 == strcmp(args[1],"global") )
        syst->set_rw_strategy(GLOBAL);

      else {
        cout << "Unknown rewriting algorithm.\n";
      }
    }

    ////  rs  ///////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"rs") ) {
      if (syst == NULL) goto no_sys;

      syst->reidemeister_schreier();
    }

    ////  seed  /////////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"seed") ) {
      if (1 >= nargs) {
        cout << "Enter random seed:  ";
        scan_long(cin,seed);
        if (get_echo() ) cout << seed << endl;
      }

      else seed = atol(args[1]);

      (void) irand( -abs( (int) seed) );
    }

    ////  settings  /////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"settings") ) {
      if (syst != NULL) bsize = syst->get_bsize();
      cout << 
      "maxlev       = " << maxlev << endl;
      cout << setprecision(3) << "\n" <<
      "bsize         = " << bsize << "\n" <<
      "hybrid_factor = " << setw(8) << hybrid_factor << "\n" <<
         setprecision(6);

      if (syst != NULL) {
        if (syst->get_use_patterns() )
          cout << "Patterns in use on rewriting." << endl;
        else
          cout << "Patterns not in use on rewriting." << endl;

        if (syst->get_use_heuristics() )
          cout << "Heuristics in use." << endl;
        else
          cout << "Heuristics not in use."  << endl;

        if (syst->get_use_broken() )
          cout << "Broken rules are being retained." << endl;
        else
          cout << "Broken rules are not being retained." << endl;

        cout << "Confluent to length " << prevlen << "\n\n";
      }
    }

    ////  shift_rules  /////////////////////////////////////////

    else if (0 == strcmp(args[0],"shift_rules") ) {
      if (NULL == syst) goto no_sys;

      if (nargs <= 1) {
        cout << "Enter maximum length of left sides:  ";
        cin  >> llmax;
        if (get_echo() ) cout << llmax << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else llmax = atol(args[1]);

      if (nargs <= 2) {
        cout << "Enter maximum length of right sides:  ";
        cin  >> lrmax;
        if (get_echo() ) cout << lrmax << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else lrmax = atol(args[2]);

      if (nargs <= 3) {
        cout << "Enter first generator to be shifted:  ";
        cin  >> firstg;
        if (get_echo() ) cout << firstg << endl;
        if (!cin.ignore(10000,'\n') ) goto clear_error;
      }

      else firstg = atol(args[3]);

      if (nargs <= 4) {
        cout <<
          "Enter max saved left side (positive integer):  ";
        cin  >> savell;

        if (get_echo() ) cout << savell << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savell = atol(args[4]);

      if (nargs <= 5) {
        cout <<
          "Enter max saved right side (nonnegative integer):  ";
        cin  >> savelr;

        if (get_echo() ) cout << savelr << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else savelr = atol(args[5]);
      
      if (nargs <= 6) {
        cout <<
          "Enter amount of shift (positive integer):  ";
        cin  >> shift;

        if (get_echo() ) cout << shift << endl;
        
        if ( !cin.ignore(10000,'\n') ) goto clear_error;
      }
      
      else shift = atol(args[6]);
      
      syst->set_save(savell,savelr);
      syst->shift_rules(llmax,lrmax,firstg,shift);
      prevlen = 0;
    }

    ////  summary  //////////////////////////////////////////////

    else if ( 0 == strcmp(args[0],"summary") ) {
      if (syst == NULL) goto no_sys;

      syst->summary();
    }


    else cout << "unknown command:  " << command << "\n";

   abort:
    continue;

   clear_error:
    cout << "Error clearing command line." << endl;
    goto cont;

   no_sys:
    cout << "There is no current system." << endl;
    goto cont;

   cont:
    if ( get_echo() ) exit(1);
  }

  return 0;
}



/////////////////////////////////////////////////////////////////
//
//                        help
//
/////////////////////////////////////////////////////////////////

void help(void)
{
  char  command[100];

  if ( nargs == 1 &&
       (0 == strcmp(args[0],"?") ||
        0 == strcmp(args[0],"help") ) ) {
    cout << "Most commands take arguments.  Entering the command with no\n";
    cout << "arguments results in prompts with descriptions.\n";
    cout << "\n";

    cout << "add_engel          Add instances of an Engel identity.\n";
    cout << "add_instances      Add instances of rule patterns.\n";
    cout << "add_powers         Add powers of reduced words as relators.\n";
    cout << "add_random_powers  Add powers of random reduced words.\n";
    cout << "add_subs           Add homomorphic images of rules.\n";
    cout << "add_subword_powers Add powers of subwords of a word.\n";
    cout << "broken             Turn on saving of broken rules.\n";
    cout << "bsize              Set the size of rewriting buffer.\n";
    cout << "cancel             Designate a monoid generator as cancelable.\n";
    cout << "conjugate          Add conjugates of prefix rules.\n";
    cout << "count              Count irreducible words.\n";
    cout << "count_subgroup     Count irreducible words in a subgroup.\n";
    cout << "countg             Count geodesics and edges in Cayley graph.\n";
    cout << "counts             Display counts of various actions.\n";
    cout << "countx             Count edges in Cayley graph by level.\n";
    cout << "details            Display profile of rules by left length.\n";
    cout << "dots               Turn on display of progress for long tasks.\n";

    if (!get_echo() ) {
      cout << "\nEnter carriage return to continue ";

      if ( !cin.ignore(10000,'\n') ) {
        cout << "I waited long enough!" << endl;
        exit(1);
      }

      cout << endl;
    }

    cout << "echo               Turn on echo of commands and arguments.\n";
    cout << "exit               Terminate the program.\n";
    cout << "free               Remove current rewriting system.\n";
    cout << "geodesics          Count geodesics in Cayley graph.\n";
    cout << "get_nonobvious     Extract a presentation from a sorted file\n";
    cout << "                    of rules.  Very time consuming.\n";
    cout << "help               Display commands.\n";
    cout << "heuristics         Turn on use of heuristics on new rules.\n";
    cout << "hybrid_factor      Set the factor for hybrid indexes.\n";
    cout << "input              Enter a new rewriting system.\n";
    cout << "kb                 Form overlaps among rules, both subword\n";
    cout << "                    and prefix.\n";
    cout << "kb_prefix          Form overlaps with prefix rules only.\n";
    cout << "kb_random          Form random overlaps.\n";
    cout << "kb_strategy        Set the Knuth-Bendix strategy.\n";
    cout << "kb_subword         Form overlaps with subword rules only.\n";
    cout << "level              Control the wreath product level of the\n";
    cout << "                    left sides in overlaps.\n";
    cout << "log                Initialize a log file.\n";

    if (!get_echo() ) {
      cout << "\nEnter carriage return to continue ";

      if ( !cin.ignore(10000,'\n') ) {
        cout << "I waited long enough!" << endl;
        exit(1);
      }

      cout << endl;
    }

    cout << "maxnew             Set the maximum number of new rules\n";
    cout << "                    found before aborting Knuth-Bendix.\n";
    cout << "memory             Display information about memory usage.\n";
    cout << "nobroken           Turn off saving of broken rules and get\n";
    cout << "                    rid of any current ones.\n";
    cout << "nodots             Turn off work-in-progress dots.\n";
    cout << "noecho             Turn off echoing of commands and arguments.\n";
    cout << "noheuristics       Turn off use of heuristics.\n";
    cout << "nolog              Turn off use of log file.\n";
    cout << "nopatterns         Turn off use of patterns in rewriting.\n";
    cout << "output             Write current rewriting system to a file.\n";
    cout << "output_rules       Write selected rules to a file.\n";
    cout << "patterns           Turn on the use of patterns in rewriting.\n";
    cout << "print_level        Specificy amount of information displayed.\n";
    cout << "probe              Estimate number of irreducible words.\n";
    cout << "probe_subword      Estimate number of subword-irreducible\n";
    cout << "                    words.\n";
    cout << "quit               Terminate the program.\n";

    if (!get_echo() ) {
      cout << "\nEnter carriage return to continue ";

      if ( !cin.ignore(10000,'\n') ) {
        cout << "I waited long enough!" << endl;
        exit(1);
      }

      cout << endl;
    }

    cout << "report_memory      Report when large blocks of memory are\n";
    cout << "                    allocated.\n";
    cout << "report_rewriting   Give details about rewriting individual\n";
    cout << "                    words.\n";
    cout << "report_timing      Not functional.\n";
    cout << "restore            Restore a previously saved rewriting\n";
    cout << "                    system.\n";
    cout << "rewrite_rules      Rewrite rules from a file.\n";
    cout << "rewrite_words      Rewrite words from a file or the terminal.\n";
    cout << "rewriting_strategy Set the rewriting strategy.\n";
    cout << "rs                 Perform a version of Reidemeister-Schreier\n";
    cout << "seed               Set the seed for the random number\n";
    cout << "                    generator.\n";
    cout << "settings           Display the values of various parameters.\n";
    cout << "shift_rules        Simulate an HNN-extension involving a\n";
    cout << "                    subgroup isomorphic to the whole group.\n";
    cout << "summary            Display some information about the current\n";
    cout << "                    rewriting system.\n";
  }

  else {
    if (nargs == 2 && 0 == strcmp(args[0],"help") )
      strcpy(args[1],command);

    else if (nargs == 1 && args[0][0] == '?')
      strcpy(args[0]+1,command);

    else return;

    cout <<
      "Sorry.  No help available yet on individual commands.\n";
  }

  return;
}



// end of rkbp.C
